﻿using System;
using System.Linq;
using System.Diagnostics;
using System.Collections;
using Telerik.Web.UI;
using System.Data;
using System.Web.UI.WebControls;
using System.Collections.Generic;
using System.Web.Services;
using System.Drawing;
using System.Web.UI;

public partial class Default : System.Web.UI.Page
{
    List<int> selectedItems = new List<int>();
    bool IsExport = false;
    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);

        RadGrid1.NeedDataSource += (s, a) =>
        {
            (s as RadGrid).DataSource = new[] 
            {
                new { Col1="AA", Col2="New York", Col3="1", Col4 = 10},
                new { Col1="AA", Col2="New York", Col3="2", Col4 = 12},
                new { Col1="AA", Col2="New York", Col3="3", Col4 = 22},
                new { Col1="AA", Col2="Chicago", Col3="3", Col4 = 22},
                new { Col1="AA", Col2="Chicago", Col3="10", Col4 = 24}
            };
        };
        RadGrid1.ItemCommand += new GridCommandEventHandler(RadGrid1_ItemCommand);
        RadGrid1.ItemCreated += new GridItemEventHandler(RadGrid1_ItemCreated);
    }

    void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
    {
        if (IsExport)
        {
            if (e.Item is GridDataItem)
            {
                if (selectedItems.Count > 0) //if there are no selected items, export all
                {
                    //toggle item visibility according to the selected indexes                               
                    e.Item.Display = selectedItems.Contains(e.Item.ItemIndex);
                }
            }

            ApplyCustomFormatting(e.Item);
        }
    }

    private void ApplyCustomFormatting(GridItem gridItem)
    {
        if (gridItem.ItemType == GridItemType.Item)
        {
            gridItem.Style.Add("background-color", "#ccc");
        }
        else if (gridItem.ItemType == GridItemType.AlternatingItem)
        {
            gridItem.Style.Add("background-color", "#eee");
        }
        else if (gridItem.ItemType == GridItemType.Header)
        {          
            //in most cases, it is neccessary to apply the styles directly to the cells of the header item because they are TH and not TD elements
            foreach (TableCell cell in gridItem.Cells)
            {
                cell.Style.Add("font-size", "14pt");
                cell.Style.Add("background-color", "#888");
                cell.Style.Add("color", "#fff");
            }
        }
    }

    void RadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
    {
        if (e.CommandName.Contains("Export"))
        {
            IsExport = true;

            //persist selected items
            foreach (GridDataItem item in RadGrid1.MasterTableView.Items)
            {
                if (item.Selected && !selectedItems.Contains(item.ItemIndex))
                {
                    selectedItems.Add(item.ItemIndex);
                }
            }
        }
    }

}